/*******************************************************************************
 * 
 * jKiwi -- A virtual makeover and hairstyler application
 * Copyright (c) 2007-2008 Dan Mihai Ile, Maria Joao Roque Barbado Leal
 * 
 * This file is part of jKiwi.
 * 
 * jKiwi is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * jKiwi is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************/

package blending;


/**
 * Grain Merge mode merges a grain layer into the current layer,
 * leaving a grainy version of the original layer. It adds the
 * pixel values of the upper and lower layers together and subtracts 128.
 * <p>
 * The equation is: R = B + T - 128
 * </p>
 */
public class GrainMergeBlendingContext extends BlendingContext {

	@Override
	public int[] applyBlending(int[] srcPixel, int[] dstPixel) {
		return new int[] {
				Math.max(0,Math.min(255, srcPixel[0] + dstPixel[0] - 128)),
				Math.max(0,Math.min(255, srcPixel[1] + dstPixel[1] - 128)),
				Math.max(0,Math.min(255, srcPixel[2] + dstPixel[2] - 128)),
				dstPixel[3] //use only dst's alpha value
		};
	}

}